config/routes.rb
# frozen_string_literal: true

require 'sidekiq/web'

Rails.application.routes.draw do
  # https://github.com/sidekiq/sidekiq/wiki/Monitoring
  mount Sidekiq::Web => '/sidekiq'

  resources :posts
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  root 'people#index'

  resources :people, only: %i[show index]

  get 'up' => 'rails/health#show'
end

app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/hystory.rb
# frozen_string_literal: true

class Hystory < ApplicationRecord
  belongs_to :person

  delegate :name, to: :person, prefix: :user
end

app/models/person.rb
# frozen_string_literal: true

class Person < ApplicationRecord
  validates :name, presence: true
  validates :email, presence: true, uniqueness: true, format: { with: /\A[^@\s]+@[^@\s]+\z/, message: 'Invalid email' }
end

app/models/post.rb
# frozen_string_literal: true

class Post < ApplicationRecord
  belongs_to :person

  after_create :hystory_created
  after_update :hystory_updated
  after_destroy :hystory_destroyed

  attr_accessor :current_user

  delegate :name, to: :person, prefix: :author

  private

  def hystory_created
    HystoryLogger.new('created', current_user.id).call
    PostNotificationJob.perform_later(self)
  end

  def hystory_updated
    HystoryLogger.new('updated', current_user.id).call
  end

  def hystory_destroyed
    HystoryLogger.new('deleted', current_user.id).call
  end
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
  def current_user
    @current_user ||= session[:user_id] && Person.find_by(id: session[:user_id])
  end
end

app/controllers/people_controller.rb
# frozen_string_literal: true

class PeopleController < ApplicationController
  before_action :take_current_user, only: %i[index]
  before_action :find_person, only: %i[show]

  # GET /people/1
  def show; end

  # GET /people
  def index
    @people = Person.all
  end

  private

  def take_current_user
    c = Person.ids
    @person = Person.find(c.sample)
    session[:user_id] = @person.id
  end

  def find_person
    @person = Person.find(params[:id])
  end
end

app/controllers/posts_controller.rb
# frozen_string_literal: true

class PostsController < ApplicationController
  before_action :inspect_current_user
  before_action :set_post, only: %i[show edit update destroy]

  # GET /posts or /posts.json
  def index
    @posts = Post.all
  end

  # GET /posts/1 or /posts/1.json
  def show; end

  # GET /posts/new
  def new
    @post = Post.new(person_id: current_user.id)
    @post.current_user = current_user
  end

  # GET /posts/1/edit
  def edit; end

  # POST /posts or /posts.json
  def create
    @post = Post.new(post_params)
    @post.current_user = current_user

    respond_to do |format|
      if @post.save
        format.html { redirect_to post_url(@post), notice: "Post from #{@post.author_name} was successfully created." }
        format.json { render :show, status: :created, location: @post }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /posts/1 or /posts/1.json
  def update
    respond_to do |format|
      if @post.update(post_params)
        format.html { redirect_to post_url(@post), notice: 'Post was successfully updated.' }
        format.json { render :show, status: :ok, location: @post }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @post.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /posts/1 or /posts/1.json
  def destroy
    @post.destroy

    respond_to do |format|
      format.html { redirect_to posts_url, notice: "Post from #{@post.author_name} was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_post
    @post = Post.find(params[:id])
    @post.current_user = current_user
  end

  # Only allow a list of trusted parameters through.
  def post_params
    params.require(:post).permit(:title, :person_id, :body)
  end

  def inspect_current_user
    redirect_to controller: 'people', action: 'index' if current_user.nil?
  end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

app/helpers/people_helper.rb
# frozen_string_literal: true

module PeopleHelper
end

app/helpers/posts_helper.rb
# frozen_string_literal: true

module PostsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>MeaPublisher</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <div class="wrapper">
      <%= yield %>
    </div>
  </body>
</html>

app/views/people/_person.html.erb
<div id="<%= dom_id person %>" class="mt-sm">
  <p>
    <strong>Name:</strong>
    <%= person.name %>
  </p>

  <p>
    <strong>Email:</strong>
    <%= person.email %>
  </p>

</div>

app/views/people/index.html.erb
<% if notice.present? %>
  <p class="mb mt message message-notice text-green"><%= notice %></p>
<% end %>

<div class="container mb-sm">
  <div class="text-title mb title-lg">
    <div>
      Hi, <%= @person.name %>!
    </div>

    <div>
      <%= link_to fa_icon('address-card'), @person,
        title: "Show information about this person" %>
    </div>
  </div>

  <div>
    <%= link_to "Go to posts", posts_path %>
  </div>
</div>

<div class="container">
  <h2 class="title-lg mb">People</h2>

  <div id="people">
    <!-- <%= render @people %> -->
    <% @people.each do |person| %>
      <%= render person %>
    <% end %>
  </div>
</div>

app/views/people/show.html.erb
<% if notice.present? %>
  <p class="mb mt message message-notice text-green"><%= notice %></p>
<% end %>

<div class="container">
  <div class="text-title mb title-lg">
    <div>
      Person
    </div>

    <div>
      <%= link_to fa_icon('bars'), people_path, title: "Back to people" %>
    </div>
  </div>

  <%= render @person %>
</div>

app/views/posts/_form.html.erb
<%= form_with(model: post) do |form| %>
  <div>
    <p><%= form.label :title %></p>
    <p><%= form.text_field :title, class: "form-text-field" %></p>
  </div>

  <div>
    <p><%= form.label :person_id %></p>
    <p><%= form.text_field :person_id, class: "form-text-field" %></p>
  </div>

  <div>
    <p><%= form.label :body %></p>
    <p><%= form.text_area :body, rows: 7, class: "form-text-area" %></p>
  </div>

  <div class="mt">
    <%= form.submit 'Save', class: "button button-main" %>
  </div>
<% end %>

app/views/posts/_post.html.erb
  <div id="<%= dom_id post %>">
    <div class="mb-sm">
      <p>
        <strong>Author:</strong>
        <%= post.author_name %>
      </p>

      <p>
        <strong>Title:</strong>
        <%= post.title %>
      </p>
      
      <p>
        <strong>Body:</strong>
        <%= post.body %>
      </p>
    </div>

    <div class="text-sm post-footer">
      <div class="text-grey">
        <%= l(post.created_at, format: :short) %>
      </div>

      <div>
        <%= link_to fa_icon('pencil'), edit_post_path(post),
          title: "Edit this post" %> |
        <%= button_to fa_icon('trash-o'), post_path(post), method: :delete,
          title: "Destroy this post" %>
      </div>
    </div>
  </div>

app/views/posts/edit.html.erb
<div class="container">
  <div class="text-title mb title-lg">
    <div>
      Editing post
    </div>

    <div>
      <%= link_to fa_icon('address-card'), post_path(@post),
        title: "Show this post" %> |
      <%= link_to fa_icon('bars'), posts_path,
        title: "Back to posts" %>
    </div>
  </div>

  <%= render "form", post: @post %>
</div>

app/views/posts/index.html.erb
<% if notice.present? %>
  <p class="mb mt message message-notice text-green"><%= notice %></p>
<% end %>

<div class="container mb-sm">
  <div class="text-title title-lg">
    <div>
      Posts
    </div>

    <div>
      <%= link_to "Add new post", new_post_path, class: "button button-main" %>
    </div>
  </div>
</div>

<div id="posts">
  <!-- <%= render @posts %> -->
  <% @posts.each do |post| %>
    <div class="mt-sm container">
      <%= render post %>
    </div>
  <% end %>
</div>

app/views/posts/new.html.erb
<% if @post.errors.any? %>
  <div class="mb mt message message-notice text-red">
    <h2><%= pluralize(@post.errors.count, "error") %> prohibited this post from being saved:</h2>

    <ul>
      <% @post.errors.each do |error| %>
        <li><%= error.full_message %></li>
      <% end %>
    </ul>
  </div>
<% end %>

<div class="container">
  <div class="text-title mb title-lg">
    <div>
      New post
    </div>

    <div>
      <%= link_to fa_icon('bars'), posts_path, title: "Back to posts" %>
    </div>
  </div>

  <%= render "form", post: @post %>
</div>

app/views/posts/show.html.erb
<% if notice.present? %>
  <p class="mb mt message message-notice text-green"><%= notice %></p>
<% end %>

<div class="container">
  <div class="text-title mb title-lg">
    <div>
      Post
    </div>

    <div>
      <%= link_to fa_icon('bars'), posts_path, title: "Back to posts" %>
    </div>
  </div>

  <%= render @post %>

</div>